## camitk 5.0.2

=== CMakeLists.txt ===
#--------------------------------------------
#
#      CamiTK Community Edition CEP Set
#
#-------------------------------------------- 
cmake_minimum_required(VERSION 3.13)

project(camitkcommunityedition)

# Allow testing of the whole camitk-communityedition project
include(CTest)
enable_testing()

set(CAMITK_PROJECT_NAME "CamiTK")
# The current version of CamiTK is defined in a separate file to avoid conflict/problem when merging
include(CamiTKVersion.cmake)
string(TOLOWER "${CAMITK_PROJECT_NAME}-${CAMITK_VERSION_MAJOR}.${CAMITK_VERSION_MINOR}" CAMITK_SHORT_VERSION_STRING)

# Specific to the Community Edition: this is the Community Edition build
set(CAMITK_COMMUNITY_EDITION_BUILD TRUE)

#-- This is a CEP set...
set(CAMITK_EXTENSION_PROJECT_SET TRUE CACHE BOOL "Is this a CamiTK Extension Project Set?")
set(CAMITK_EXTENSION_PROJECT_SET_NAME "camitk-communityedition" CACHE STRING "CEP Set Name")

# Configure CamiTK Community Edition packaging.
# Must be done before parsing extensions CMakeLists.txt files.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules/macros ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules)
set(CAMITK_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
include(camitk/packaging/CamiTKCommunityEditionPackaging)
camitk_communityedition_packaging()

# Configure include-what-you-use to check the current target
include(camitk/test/CamiTKIncludeWhatYouUse)

# CamiTK requires C++11
# All target after this declaration will be compile with c++11 policy
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF) # for wider compatibility across plateforms and compiler

# Specific to SDK: first compile the SDK (it looks like a CEP but is sooooo special...)
add_subdirectory(sdk)

# ...composed by the following CamiTK Extension Projects (optional)
add_subdirectory(imaging)
add_subdirectory(modeling)

# ... and tutorials that helps understand CamiTK (optional)
add_subdirectory(tutorials)


# Do we wrapp CamiTK for scripting it into Python using Shiboken and PySide ?
set(CAMITK_BINDING_PYTHON CACHE BOOL FALSE)

# Consider python binding only if the CMake variable is checked
if(CAMITK_BINDING_PYTHON)
    add_subdirectory(python_sdk)
endif()


camitk_write_manifest_data(CEP_SET)

=== modeling/CMakeLists.txt ===
#--------------------------------------------
# Modeling extension project
#--------------------------------------------
# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

# Sofa support is defined in separate files
include(SofaSupport.cmake)
# uncomment the following line for old versions of sofa: at your own risk!
#include(SofaLegacySupport.cmake) 

# For packaging on windows, dash cannot be used as separator
# => replace it by underscore
if (PACKAGING_NSIS)
    set(TARGET_NAME_SEPARATOR _)
else()
    set(TARGET_NAME_SEPARATOR -)
endif()

camitk_extension_project(NAME "modeling"
                         CONTACT "Celine.Fouard@univ-grenoble-alpes.fr,Emmanuel.Promayon@univ-grenoble-alpes.fr"
                         DESCRIPTION "This CamiTK Extension Project is part of CamiTK Community Edition. It contains all the action and component extensions that are useful for biomechanical processing. It provides the LML, PML and MML libraries, and the related components and actions."
)

=== sdk/CMakeLists.txt ===
#--------------------------------------------
#               CamiTK SDK
#
# You should probably NOT modify this file...
# Please edit CEPDescription.cmake instead
#--------------------------------------------
include(SDKConfig.cmake) 

# Configure CamiTK test coverage report generation (if and only if CAMITK_TEST_COVERAGE is set to TRUE)
include(camitk/test/CamiTKTestCoverage)

message(STATUS "Compilation build type: ${CMAKE_BUILD_TYPE}")
if (CAMITK_TEST_COVERAGE)
    message(STATUS "Test coverage: enabled")
else()
    message(STATUS "Test coverage: disabled")
endif()

# include global install of SDK
# This is a SDK build => global install is done in CMAKE_INSTALL_PREFIX
add_custom_target(camitk-ce-global-install
    COMMAND ${CMAKE_COMMAND} -E echo "Global Installation in ${CMAKE_INSTALL_PREFIX}"
    # First remove the WIN32 system runtime libraries dependencies
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_SYSTEM_RUNTIME_LIBS:STRING=" " ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."
    # Second cmake to install
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target camitk-ce-copy-camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} -E echo "Global installation in ${CMAKE_INSTALL_PREFIX} done."
    COMMENT "Global installation"
)

# The definition of SDK_TOP_LEVEL_SOURCE_DIR and SDK_TOP_LEVEL_BINARY_DIR are
# are needed to store the current source dir to pass as an argument to the ConfigureCamiTKDirTxt.cmake script in camitk-ce-copy-camitkdirtxt
set(SDK_TOP_LEVEL_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SDK_TOP_LEVEL_BINARY_DIR ${CMAKE_BINARY_DIR})
# specific top-level target that prepare and copy the CamiTKDir.txt file in ${CAMITK_USER_DIR}
add_custom_target(camitk-ce-copy-camitkdirtxt
    # prepare the CamiTKConfig.cmake for installation
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
                             -DCAMITK_USER_DIR=${CAMITK_USER_DIR}
                             -DSDK_TOP_LEVEL_SOURCE_DIR=${SDK_TOP_LEVEL_SOURCE_DIR}
                             -DSDK_TOP_LEVEL_BINARY_DIR=${SDK_TOP_LEVEL_BINARY_DIR}
                             -P ${CMAKE_CURRENT_SOURCE_DIR}/ConfigureCamiTKDirTxt.cmake
    # Make sure the user dir exists
    COMMAND ${CMAKE_COMMAND} -E make_directory "${CAMITK_USER_DIR}"
    # Remove the previous version
    COMMAND ${CMAKE_COMMAND} -E remove -f ${CAMITK_USER_DIR}/CamiTKDir.txt
    # Copy the CamiTKDir.txt file in the ${CMAKE_USER_DIR} directory
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/CamiTKDir.txt ${CAMITK_USER_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "CamiTKDir.txt [${CMAKE_INSTALL_PREFIX}] copied in ${CAMITK_USER_DIR}"
)

# camitk-ce-local-install == install in User Config directory
add_custom_target(camitk-ce-local-install
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR}"
    # First cmake to redefine install prefix
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CAMITK_USER_DIR} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."    
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target camitk-ce-copy-camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR} done."
    COMMENT "Local installation"
)

# camitk-ce-update-translate == configure all the .qrc files for the different extensions of the SDK.
# .qrc files consider up to date .ts resources files for translation
add_custom_target(camitk-ce-update-translate
    COMMAND ${CMAKE_COMMAND} -E echo "Updating translation for CamiTK Community Edition"
    COMMAND ${CMAKE_COMMAND} -DCAMITK_TRANSLATE=TRUE ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -DCAMITK_TRANSLATE=FALSE ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Translation updated for CamiTK Community Edition"    
)

# make sure a copy of the CamiTKDir.txt file is written to ${CAMITK_USER_DIR}
# even if the user is just invoking the "install" target (from the IDE or command line)
install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target camitk-ce-copy-camitkdirtxt)")

# include CamiTK auto-documentation generation
include(CamiTKApiDoc)

# initialize subproject management
camitk_init_manifest_data()

# Create a shiboken path variable containing the CamiTK SDK tree structure, needed by shiboken to find C++ classes to wrap
set(SHIBOKEN_CAMITK_SDK_PATH ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")

# initialize automatic tests parsing
camitk_parse_test_init()

# add all subprojects, in dependencies order
#
# Note: testapplications are easier to manage if they are in a separate directory
# As testapplications are required to test actions and components but depends on library core,
# it is easier to keep them in a separate (specific) folder.
# -> dependencies are satisfied (thanks to camitk_extension macros
# -> parallel build is not broken
camitk_add_subdirectory(libraries)
camitk_add_subdirectory(testapplications)
camitk_add_subdirectory(components)
camitk_add_subdirectory(viewers)
camitk_add_subdirectory(actions)
camitk_add_subdirectory(applications)
camitk_add_subdirectory(cmake) # for cmake module installation

# Validate project.xml file for CDash
camitk_write_manifest_data()

# Validate CamiTKTestsLevel.txt file for wiki
camitk_parse_test_validate()

=== imaging/actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro appropriately

# find components
get_subdirectories(ACTIONS_LIST)

# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_LIST})
  camitk_add_subdirectory(${ACTION_NAME})
endforeach()

=== imaging/applications/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add an application, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_application() macro appropriately

# Find applications
get_subdirectories(APPLICATIONS_LIST)

# --- add every given application
foreach(APPLICATION_NAME ${APPLICATIONS_LIST})
   camitk_add_subdirectory(${APPLICATION_NAME})
endforeach()

=== sdk/actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro appropriately

# find components
get_subdirectories(ACTIONS_LIST)

# Recursively update the shiboken path variable containing the CamiTK SDK tree structure
set(SHIBOKEN_CAMITK_SDK_PATH ${SHIBOKEN_CAMITK_SDK_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "") 

# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_LIST})
  camitk_add_subdirectory(${ACTION_NAME})
endforeach()

=== sdk/doc/CMakeLists.txt ===
camitk_add_subdirectory(resources/actions)

=== sdk/viewers/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro appropriately

# find components
get_subdirectories(VIEWERS_LIST)

# Recursively update the shiboken path variable containing the CamiTK SDK tree structure
set(SHIBOKEN_CAMITK_SDK_PATH ${SHIBOKEN_CAMITK_SDK_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "") 

# Add subdirectories in CMake project
foreach(VIEWER_NAME ${VIEWERS_LIST})
  camitk_add_subdirectory(${VIEWER_NAME})
endforeach()

=== tutorials/components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(COMPONENT_EXTENSION ...) macro apropriately

# find components
get_subdirectories(COMPONENTS_LIST)

# Add subdirectories in CMake project
foreach(COMPONENT_NAME ${COMPONENTS_LIST})
  add_subdirectory(${COMPONENT_NAME})
endforeach()

=== imaging/actions/itkfilters/CMakeLists.txt ===
if (WIN32)
    if(CMAKE_CL_64)
        # for 64 bits platform, enable big obj (.o) handling, in order to correctly compile this (heavy) project
        if (MSVC)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
        elseif(MINGW)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -finline-functions")
        endif()
    endif()
endif()

camitk_extension(ACTION_EXTENSION
                 NEEDS_ITK
                 CXX_FLAGS "-w"
                 CEP_NAME CEP_IMAGING
                 DESCRIPTION "This action features basic ITK image processing filters"
                 DEFINES COMPILE_ITKFILTER_API
                 ENABLE_AUTO_TEST
                 TEST_FILES bassin.msh BigEndian.hdr BigEndian.img BigEndianCompressed1.hdr BigEndianCompressed1.img biorad.pic brain.mha cthead1.lsm LittleEndian1.hdr LittleEndian1.img LittleEndianCompressed1.hdr LittleEndianCompressed1.img LittleEndianZ1.hdr mini-complex-slow1.nrrd mini-ten-nomask-slow1.nrrd mini-vector-slow1.nrrd ramp1.gipl
                 ENABLE_INTEGRATION_TEST
)

# --------------------------------
# --- Specific test management ---
# --------------------------------
camitk_disable_tests(TESTS action-itkfilters-level1-6
                           action-itkfilters-level1-8
                           action-itkfilters-level1-14
                     REASON " Test failure due to ITK exception.
   For now disable these tests until this can be taken care of in the save() method
   For input file: biorad.pic, cthead1.lsm, mini-complex-slow1.nrrd
   When applying action Gradient Magnitude With Smoothing, the following exception is raised:
   \"camitk-testcomponents aborted by std exception: /usr/include/ITK-4.10/itkRecursiveSeparableImageFilter.hxx:245:
   itk::ERROR: RecursiveGaussianImageFilter(0x55b3b21bc700): The number of pixels along direction 2 is less than 4. 
   This filter requires a minimum of four pixels along the dimension to be processed...\""
)

camitk_tests_requirement(TESTS action-itkfilters-integration-test
                         REQUIRES "NOT WIN32"
                         REASON "WIN32 OpenGL failure on a VM
   This test will always fail when run inside a VM due to OpenGL crash.
   This test will pass when run directly from a physical windows machine."
)

camitk_tests_requirement(TESTS action-itkfilters-integration-test
                         REQUIRES "${VTK_VERSION} VERSION_EQUAL 7.1.1"
                         REASON "VTK version is not equals than 7.1.1
   The default test files are written using the currently supported version of VTK (VTK 7.1).
   This test will therefore fail when comparing the input to the output if another version of VTK is used.
   Although everything should work fine, the output diff will make this test unconditionnaly fail."
)

=== imaging/components/dicom/CMakeLists.txt ===
camitk_extension(COMPONENT_EXTENSION
                 NEEDS_GDCM
                 CEP_NAME CEP_IMAGING
                 DESCRIPTION "This extension adds support for DICOM single image file (.dcm) and series thanks to the gdcm library"
                 INSTALL_ALL_HEADERS
                 ENABLE_AUTO_TEST
)

=== imaging/components/itkimage/CMakeLists.txt ===
# itkimage component just needs to use the component_extension macro
camitk_extension(COMPONENT_EXTENSION 
                 NEEDS_ITK 
                 CEP_NAME CEP_IMAGING
                 CXX_FLAGS "-w"
                 DEFINES _SCL_SECURE_NO_WARNINGS # to remove Windows MSVC warnings
                 DESCRIPTION "This component allows CamiTK to handle basic ITK format images."
                 ENABLE_AUTO_TEST
)

# --------------------------------
# --- Specific test management ---
# --------------------------------

camitk_disable_tests(TESTS component-itkimage-level3-3
                           component-itkimage-level3-9 
                           component-itkimage-level3-10
                           component-itkimage-level3-19
                           component-itkimage-level3-20
                     REASON " Test failure due to ITK exception.
   For now disable these tests until this can be dealt with (if possible)
   For input file: biorad.pic, cthead1.lsm, BigEndian.spr, LittleEndianZ.hdr and LittleEndianZ.img.gz
   When applying action Gradient Magnitude With Smoothing, the following exception is raised:
   \"camitk-testcomponents aborted by std exception: /usr/include/ITK-4.10/itkRecursiveSeparableImageFilter.hxx:245:
   itk::ERROR: RecursiveGaussianImageFilter(0x55b3b21bc700): The number of pixels along direction 2 is less than 4. 
   This filter requires a minimum of four pixels along the dimension to be processed...\""
)

# TODO confirm diagnostic: check why BigEndianCompressed.img.gz, LittleEndianCompressed.img.gz and minimal.nii.gz does not work on Windows (maybe because of double suffix .im.gz?)
camitk_tests_requirement(TESTS component-itkimage-level3-6 
                               component-itkimage-level3-16 
                               component-itkimage-level3-28
                         REQUIRES "NOT WIN32"
                         REASON "WIN32 failure (probably) due to double suffix .im.gz or .nii.gz
   For input file: BigEndianCompressed.img.gz, LittleEndianCompressed.img.gz and minimal.nii.gz"
)

camitk_tests_requirement(TESTS component-itkimage-level3-1
                               component-itkimage-level3-4
                               component-itkimage-level3-7
                               component-itkimage-level3-11
                               component-itkimage-level3-13
                               component-itkimage-level3-15
                               component-itkimage-level3-17
                               component-itkimage-level3-21
                               component-itkimage-level3-28
                         REQUIRES "${ITK_VERSION} VERSION_EQUAL 4.13.2"
                         REASON "ITK version version 4.13.2
   The default test files are written using the currently supported version of ITK (ITK 4.13.2).
   This test will therefore fail when comparing the input to the output if another version of ITK is used."
)

# Additional test for SDK actions: this will add auto test for the given actions using the itkimage component
camitk_additional_action_test(ACTION_EXTENSIONS cropvolume imagelut imageresampling multipicking pixelcolorchanger reconstruction reorientimage showin3d volumerendering
                              TEST_FILES BigEndian.hdr BigEndian.img BigEndianCompressed1.hdr BigEndianCompressed1.img biorad.pic cthead1.lsm LittleEndian1.hdr LittleEndian1.img LittleEndianCompressed1.hdr LittleEndianCompressed1.img LittleEndianZ1.hdr mini-complex-slow1.nrrd mini-ten-nomask-slow1.nrrd mini-vector-slow1.nrrd ramp1.gipl
)

=== debian/changelog ===
camitk (5.0.2-5) unstable; urgency=medium

  [ Andreas Tille ]
  * Build against VTK9
    Closes: #1013153
  * Standards-Version: 4.6.2
  * ignore test failures to unblock vtk7 removal

  [ Pierre Gruet ]
  * Providing the directories of needed JDK shared libs in LD_LIBRARY_PATH
    for the build-time tests

  [ Emmanuel Promayon ]
  * VTK9 compat, disabling dicom component for now

 -- Andreas Tille <tille@debian.org>  Thu, 22 Jun 2023 08:00:26 +0200

camitk (5.0.2-4) unstable; urgency=medium

  * Team upload.
  * d/control: declare compliance to standards version 4.6.1.
  * d/copyright: dedicate paragraph to the LGPL-2.1.
  * d/copyright: fix location of python_sdk/pyside_global.h.
  * d/u/lintian-overrides: override false positive error.
  * Rebuild with libinsighttoolkit5-dev, which disappeared temporarily from sid
    somehow. (Closes: #1017220)

 -- Étienne Mollier <emollier@debian.org>  Fri, 30 Sep 2022 21:09:45 +0200

camitk (5.0.2-3) unstable; urgency=medium

  * Fix FTBFS during build all and build any

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Thu, 24 Feb 2022 14:42:18 +0100

camitk (5.0.2-2) unstable; urgency=medium

  * Add missing Copyright entry
    Closes: #1005885

 -- Andreas Tille <tille@debian.org>  Wed, 16 Feb 2022 19:21:57 +0100

camitk (5.0.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * (Build-)Depends libinsighttoolkit5-dev
  * Bump package version number and version numbers in Breaks fields
  * Build-Depends: libgdcm-tools
  * Adapt lintian-overrides to soversion

  [ Jose Luis Rivero ]
  * Fix compilation by removing ixx files
    Closes: #997120

  [ Emmanuel Promayon ]
  * Update d/r and fix test error to improve multiarch support
  * Update autopkgtest for new upstream version
  * Disable unnecessary generation of dot graph for apidoc
  * Add d/not-installed for not packaged binaries
  * Update metadata to add upstream repo information

 -- Andreas Tille <tille@debian.org>  Wed, 09 Feb 2022 10:40:32 +0100

=== debian/control ===
Source: camitk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libvtk9-dev,
               libvtk9-qt-dev,
               qtbase5-dev,
               libqt5xmlpatterns5-dev,
               libqt5opengl5-dev,
               qttools5-dev-tools,
               xsdcxx,
               libinsighttoolkit5-dev,
               libfftw3-dev,
               libgdcm-dev,
               libgdcm-tools,
               libvtkgdcm-dev,
               xvfb,
               xauth,
               doxygen,
               graphviz,
               debhelper
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/camitk
Vcs-Git: https://salsa.debian.org/med-team/camitk.git
Homepage: https://camitk.imag.fr/
Rules-Requires-Root: no

Package: libcamitk5
Architecture: any
Section: libs
Depends: libqtpropertybrowser5 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-config
Description: Computer Assisted Medical Intervention Tool Kit - runtime
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the shared libraries needed to run CamiTK applications.

Package: camitk-config
Architecture: any
Depends: libcamitk5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libcamitk4
Replaces: libcamitk4
Description: Computer Assisted Medical Intervention Tool Kit - config
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains a command-line application to diagnose and check
 the CamiTK configuration and environment setup.

Package: libcamitk-dev
Architecture: any
Section: libdevel
Depends: libcamitk5 (= ${binary:Version}),
         camitk-config,
         libqtpropertybrowser-dev,
         cmake,
         libvtk9-dev,
         libvtk9-qt-dev,
         qtbase5-dev,
         libqt5xmlpatterns5-dev,
         libqt5opengl5-dev,
         qttools5-dev-tools,
         xsdcxx,
         libinsighttoolkit5-dev,
         libfftw3-dev,
         libgdcm-dev,
         libvtkgdcm-dev,
         xvfb,
         xauth,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: camitk-imp
Suggests: camitk-actionstatemachine
Breaks: libcamitk4-dev,
        libvtk6-dev,
        libvtk6-java,
        libvtk6-jni,
        libvtk6-qt-dev,
        libvtk7-dev,
        libvtk7-java,
        libvtk7-jni,
        libvtk7-qt-dev
Replaces: libcamitk4-dev
Description: Computer Assisted Medical Intervention Tool Kit - development
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains development files needed to build CamiTK applications.
 This package also provides the CamiTK wizard application to create new
 extensions.

Package: libcamitk5-data
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - data
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the examples and test data for CamiTK.

Package: libcamitk5-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - documentation
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the documentation for CamiTK.

Package: camitk-imp
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: camitk-actionstatemachine
Description: workbench application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-imp is the CamiTK workbench application where you can test
 all available extensions for prototyping.
 It provides an easy and interactive access to all available data and
 algorithm parameters, including the one you build yourself using
 the CamiTK SDK.
 .
 For example, camitk-imp can visualize medical images from a lot of different
 (standard) formats, offers image processing and segmentation algorithms to
 reconstruct a mesh geometry and run a biomechanical simulation.

Package: camitk-actionstatemachine
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-imp
Description: pipeline replay application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-actionstatemachine is able to replay a pipeline (workflow) of CamiTK
 actions.
 This application takes an CamiTK augmented version of a SCXML subset as input
 and allow on to replay interactive the described state-machine containing a
 list of CamiTK actions and transitions.

Package: libqtpropertybrowser5
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libqtpropertybrowser4
Replaces: libqtpropertybrowser4
Description: Qt Property Browser Library - runtime
 A framework providing a set of graphical editors for
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains the shared libraries needed to run applications
 linked against libqtpropertybrowser5.

Package: libqtpropertybrowser-dev
Architecture: any
Section: libdevel
Depends: libqtpropertybrowser5 (= ${binary:Version}),
         ${misc:Depends}
Breaks: libqtpropertybrowser4-dev
Replaces: libqtpropertybrowser4-dev
Description: Qt Property Browser Library - development
 A framework providing a set of graphical editors for
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains development files needed to build applications
 using Qt Property Browser

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export JAVA_HOME=/usr/lib/jvm/default-java

# CamiTK version from d/changelog)
include /usr/share/dpkg/pkg-info.mk
FULL_VERSION := $(shell echo '$(DEB_VERSION)' | sed -e 's/^[[:digit:]]*://' -e 's/[~-].*//')
VER_MAJOR := $(shell echo '$(FULL_VERSION)' | cut -f1 -d".")
VER_MINOR := $(shell echo '$(FULL_VERSION)' | cut -f2 -d".")
VER_SHORT=$(VER_MAJOR).$(VER_MINOR)

# package aliases (see d/control)
pkg_lib = libcamitk$(VER_MAJOR)
pkg_qpb = libqtpropertybrowser$(VER_MAJOR)
pkg_cfg = camitk-config
pkg_dev = libcamitk-dev
pkg_qpb_dev = libqtpropertybrowser-dev
pkg_data = libcamitk$(VER_MAJOR)-data
pkg_doc = libcamitk$(VER_MAJOR)-doc
pkg_imp = camitk-imp
pkg_asm = camitk-actionstatemachine
PKG_LIB_DIR := $(CURDIR)/debian/$(pkg_lib)/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)
LIB_BUILD_DIR := $(CURDIR)/camitk-build/lib/$(DEB_HOST_MULTIARCH)
PRIVATE_LIB_BUILD_DIR := $(LIB_BUILD_DIR)/camitk-$(VER_SHORT)

# multi-arch support
include /usr/share/dpkg/architecture.mk

# CMake flags are of two types:
# - generic (to tell cmake to build proper binaries)
# - CamiTK specific options
# Notes:
# - if you would like a more verbose camitk at run-time,
#   you can add -DCAMITK_LOG_LEVEL=2
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_SKIP_RPATH:BOOL=TRUE \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=FALSE \
	-DCMAKE_BUILD_TYPE:STRING=None \
	\
	-DCEP_IMAGING:BOOL=TRUE \
	-DCEP_MODELING:BOOL=TRUE \
	-DCEP_TUTORIALS:BOOL=TRUE \
	-DCOMPONENT_DICOM:BOOL=FALSE \
	\
	-DAPIDOC_SDK:BOOL=TRUE

%:
	dh $@ --builddirectory=camitk-build

override_dh_auto_configure:
	# modify libdir to include multiarch
	sed -i 's+libDir = "lib";+libDir = "lib/$(DEB_HOST_MULTIARCH)";+g' sdk/libraries/core/CamiTKVersion.h
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# let's be smart with doc
override_dh_auto_build-indep:
	# Building API DOC
	dh_auto_build -- camitk-ce-api-doc
	# Building all (required to avoid cmake error)
	dh_auto_build

# No tests needed for docs
override_dh_auto_test-indep:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "No tests availaible just for the docs"
endif

# run all the available tests (only for Archictecture: any
# as tests can only be run if and once the framework is build)
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Use the CamiTK test suite
	# Note: all tests require an X server, xvfb-run is needed to have a virtual one
	# Another way: xvfb-run --auto-servernum $(MAKE) -C camitk-build ARGS="-V" test
	# e.g. to test config: (cd camitk-build && xvfb-run --auto-servernum --server-args="-screen 0 1024x768x24" ctest -VV --timeout 1800 -R application-config)
	# The build dir path is needed for extensions, public and private libraries during test
	# to know about all camitk extension directories and properly manage inner-dependencies
	# between extensions (i.e., mml component extension depends on physicalmodel component extensions)
	# Lib dependencies can be in any extensions (viewers, component and action extensions) lib directory
	export LD_LIBRARY_PATH=$(LIB_BUILD_DIR)/:$(PRIVATE_LIB_BUILD_DIR)/viewers/:$(PRIVATE_LIB_BUILD_DIR)/components/:$(PRIVATE_LIB_BUILD_DIR)/actions/:$(PRIVATE_LIB_BUILD_DIR)/:$(JAVA_HOME)/lib/:$(JAVA_HOME)/lib/server/ ; \
	(cd camitk-build && xvfb-run --auto-servernum --server-args="-screen 0 1024x768x24" ctest -V --timeout 1800) || true # FIXME: ignore test failures to unblock vtk7 removal
endif

# packages for specific arch
override_dh_install:
	# $(CURDIR) is the current source dir
	# camitk dynamic library
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkcore.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libmonitoring.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/viewers/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/actions/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/components/lib*.so.*

	# camitk-config package contains only the app, man page and icon
	dh_install -p$(pkg_cfg) --autodest debian/tmp/usr/bin/camitk-config
	dh_install -p$(pkg_cfg) --autodest debian/tmp/usr/share/pixmaps/camitk-config.xpm
	dh_installman -p$(pkg_cfg) debian/tmp/usr/share/man/man1/camitk-config.1

	# separate packaging for qtpropertybrowser (can be used independently from camitk)
	dh_install -p$(pkg_qpb) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libqtpropertybrowser.so.*

	# camitk developer package
	# camitk so and headers and static libs
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkcore.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libmonitoring.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/viewers/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/actions/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/components/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/lib*.a
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/camitkcore
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/cepcoreschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/cepgenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/viewers
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/actions
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/components
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/pmlschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/pml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/lmlschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/lml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/mmlschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/monitoring
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/monitoringgui
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/manifest/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/packaging/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/test/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/test/level/*.cmake
	# wizard
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-wizard
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-wizard.1
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/applications/camitk-wizard.desktop
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/pixmaps/camitk-wizard.xpm
	# cepgenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-cepgenerator
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-cepgenerator.1
	# test programs
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-testactions
